TankHelp_UpdateInterval = 0.1;
TankHelpWatch = ""
TankHelpWatchName = ""
TankHelpVariablesLoaded = false;  -- Saved variables not loaded yet
currentlySelectedDebuff = ""

--6.0
--default config variables
TankHelpConfig= {}
DebuffDesc  = {
	["Lightning Lash"] = "Feng the Accursed",			-- Feng
	["Flaming Spear"] = "Feng the Accursed",			-- Feng
	["Arcane Shock"] = "Feng the Accursed",			-- Feng
	["Overwhelming Assault"] = "Blade Lord Ta'yak",	-- Blade Lord Ta'yak
	["Eyes of the Empress"] = "Grand Empress Shek'zeer",	-- Grand Empress Shek'zeer
	["Shadow Breath"] = "Tsulong",			-- Tsulong
	["Spray"] = "Lei Shi",					-- Lei Shi
	["Static Wound"] = "Jin'Rokh",    		-- Jin'Rokh
	["Triple Puncture"] = "Horridon, no switch depending on stack count",    	-- Horridon, no switch depending on stack count
	["Frigid Assault"] = "Council",    	-- Council
	["Talon Rake"] = "Ji'Kun",				-- Ji'Kun
	["Serious Wound"] = "Durumu",			-- Durumu
	["Malformed Blood"] = "Primordius",		-- Primordius
	["Impale"] = "Iron Qon",					-- Iron Qon
	["Beast of Nightmares"] = "Lu'lin", 	-- Lu'lin
	["Fan of Flames"] = "Suen",			-- Suen
	["Decapitate"] = "Lei Shen",				-- Lei Shen
	["Fusion Slash"] = "Lei Shen",			-- Lei Shen
	["Overwhelming Power"] = "Lei Shen",	-- Lei Shen (taunt when own stacks are off)
	["Corrosive Blast"] = "Immerseus",		-- Immerseus
	["Self Doubt"] = "Norushen",				-- Norushen
	["Wounded Pride"] = "Sha of Pride",			-- Sha of Pride
	["Flames of Galakrond"] = "Galakras",	-- Galakras, check stacks
	["Ignite Armor"] = "Iron Juggernaut",			-- Iron Juggernaut
	["Froststorm Strike"] = "Dark Shaman",		-- Dark Shaman, check stacks
	["Sundering Blow"] = "General Nazgrim",			-- General Nazgrim
	["Fatal Strike"] = "Malkorok",			-- Malkorok
	["Panic"] = "Thok",					-- Thok
	["Acid Breath"] = "Thok",			-- Thok
	["Freezing Breath"] = "Thok",		-- Thok
	["Scorching Breath"] = "Thok",		-- Thok
	["Electrostatic Charge"] = "Siegecrafter",	-- Siegecrafter, Taunt on Automated Shredder summon, not stacks
	["Gripping Despair"] = "Garrosh",		-- Garrosh
}


TankHelpConfig = {
	["Enabled"] = 1,				-- Is the addon enabled?
	["IfTank"] = 1,				-- Only load if the player is in tank spec
	["Locked"] = 0,					-- Frames locked?
	["OnlyRaid"] = 1,					-- Only load in raid
	["x"] = 0,		--position
	["y"] = 0, 		--position
	["point"] = "CENTER",			--position
	["relativePoint"] = "CENTER",	--position
	["ShowTaunt"] = true,
};


--class colors
	CLASS_COLORS = {
	["HUNTER"] = {0.67,0.83,0.45},
	["WARLOCK"] = {0.58,0.51,0.79},
	["PRIEST"] = {1.0,1.0,1.0},
	["PALADIN"] = {0.96,0.55,0.73},
	["MAGE"] = {0.41,0.8,0.94},
	["ROGUE"] = {1.0,0.96,0.41},
	["DRUID"] = {1.0,0.49,0.04},
	["SHAMAN"] = {0.0,0.44,0.87},
	["WARRIOR"] = {0.78,0.61,0.43},
	["DEATHKNIGHT"] = {0.77,0.12,0.23},
	["MONK"] = {0.00,1.00,0.59},
    ["ENEMY"] = {1.0,0.1,0.1};
    ["FRIEND"] = {0,1.0,0};
	};

--debuffs
DEBUFFS = {
	-- Havent checked debuff names and stack requirements, or if its even needed to switch on any fights till about ToT
	["Lightning Lash"] = 3,			-- Feng
	["Flaming Spear"] = 4,			-- Feng
	["Arcane Shock"] = 4,			-- Feng
	["Overwhelming Assault"] = 3,	-- Blade Lord Ta'yak
	["Eyes of the Empress"] = 3,	-- Grand Empress Shek'zeer
	["Shadow Breath"] = 1,			-- Tsulong
	["Spray"] = 14,					-- Lei Shi
	["Static Wound"] = 1,    		-- Jin'Rokh
	["Triple Puncture"] = 200,    	-- Horridon, no switch depending on stack count
	["Frigid Assault"] = 10,    	-- Council
	["Talon Rake"] = 3,				-- Ji'Kun
	["Serious Wound"] = 5,			-- Durumu
	["Malformed Blood"] = 6,		-- Primordius
	["Impale"] = 3,					-- Iron Qon
	["Beast of Nightmares"] = 1, 	-- Lu'lin
	["Fan of Flames"] = 2,			-- Suen
	["Decapitate"] = 1,				-- Lei Shen
	["Fusion Slash"] = 1,			-- Lei Shen
	["Overwhelming Power"] = 30,	-- Lei Shen (taunt when own stacks are off)
	["Corrosive Blast"] = 1,		-- Immerseus
	["Self Doubt"] = 3,				-- Norushen
	["Wounded Pride"] = 1,			-- Sha of Pride
	["Flames of Galakrond"] = 3,	-- Galakras, check stacks
	["Ignite Armor"] = 3,			-- Iron Juggernaut
	["Froststorm Strike"] = 5,		-- Dark Shaman, check stacks
	["Sundering Blow"] = 3,			-- General Nazgrim
	["Fatal Strike"] = 12,			-- Malkorok
	["Panic"] = 3,					-- Thok
	["Acid Breath"] = 3,			-- Thok
	["Freezing Breath"] = 3,		-- Thok
	["Scorching Breath"] = 3,		-- Thok
	["Electrostatic Charge"] = 999,	-- Siegecrafter, Taunt on Automated Shredder summon, not stacks
	["Gripping Despair"] = 3,		-- Garrosh
	-- ["Tigereye Brew"] = 7,			-- Test!
};



function TankHelp_OnLoad(THFrame)
	THFrame:RegisterForDrag("LeftButton")

	-- UnitPopupButtons["TankHelpUnitMenu"] = { text = "Set TankHelp", dist = 0 }
	-- table.insert(UnitPopupMenus["RAID"],#UnitPopupMenus["RAID"] - 1, "TankHelpUnitMenu")
	
	TankHelpSelfFrame:SetAttribute("unit", "player");
	
end


function TankHelp_OnEvent(self, event)
	if ( event == "ADDON_LOADED" ) then
		if( TankHelpConfig["Locked"] == 1 ) then
			_G["TankHelpOptions".."CheckButtonLock"]:SetChecked(true)
		else
			_G["TankHelpOptions".."CheckButtonLock"]:SetChecked(false)
		end
		if( TankHelpConfig["Enabled"] == 1 ) then
			_G["TankHelpOptions".."CheckButtonLoad"]:SetChecked(true)
		else
			_G["TankHelpOptions".."CheckButtonLoad"]:SetChecked(false)
		end
		if( TankHelpConfig["IfTank"] == 1 ) then
			_G["TankHelpOptions".."CheckButtonIfTank"]:SetChecked(true)
		else
			_G["TankHelpOptions".."CheckButtonIfTank"]:SetChecked(false)
		end
		if( TankHelpConfig["OnlyRaid"] == 1 ) then
			_G["TankHelpOptions".."CheckButtonOnlyRaid"]:SetChecked(true)
		else
			_G["TankHelpOptions".."CheckButtonOnlyRaid"]:SetChecked(false)
		end
		if( TankHelpConfig["ShowTaunt"] == 1 ) then
			_G["TankHelpOptions".."CheckButtonTaunt"]:SetChecked(true)
		else
			_G["TankHelpOptions".."CheckButtonTaunt"]:SetChecked(false)
		end
		
		_G["TankHelpSelfFrame"]:SetPoint(TankHelpConfig["point"], nil, TankHelpConfig["relativePoint"], TankHelpConfig["x"], TankHelpConfig["y"])
		
		TankHelpVariablesLoaded = true;
		
	end
	
	if( event == "GROUP_ROSTER_UPDATE" or event == "ACTIVE_TALENT_GROUP_CHANGED") then
		if(  (TankHelpConfig["OnlyRaid"] == 1 and not(UnitInRaid("player"))) or TankHelpConfig["Enabled"] == 1 or ( not(GetSpecializationRole(GetSpecialization("player")) == "TANK") and TankHelpConfig["IfTank"] == 1 ) ) then
				_G["TankHelpMainButton"]:Hide()
			else
				_G["TankHelpMainButton"]:Show()
		end
		
	end
	
	
	
end



local function setTankHelpWatch(PlayerWatchString, newWatch)
	
	if(newWatch == 1) then
		TankHelpWatchString = PlayerWatchString
	end
	
	if(TankHelpWatchString) then
		if(UnitInRaid("player")) then
			for n = 1, 40, 1 do
				if(GetRaidRosterInfo(n)) then
					-- if (PlayerWatchString == strsub(GetRaidRosterInfo(n), 1, string.len(PlayerWatchString))) then
					if (TankHelpWatchString == strsub(GetRaidRosterInfo(n), 1, string.len(TankHelpWatchString))) then
						TankHelpWatch = "raid"..(n)
						
					end
				end
			end
			
		else
			-- print("Player not in party or raid")
		end
	end
end


-- local function TankHelpUnitMenu_OnClick(level, value, dropDownFrame, anchorName, xOffset, yOffset, menuList, button, autoHideDelay)
	-- --if value ~= "TankHelpUnitMenu" then return end -- If this wasn't our button, don't do anything.
	-- if (dropDownFrame and level) then
	
        -- local buttonPrefix = "DropDownList" .. level .. "Button";
		
		-- local i = 2
		-- while (1) do
			-- local button = _G[buttonPrefix..i]
			-- if (not button) then break end
			
			-- if (button:GetText() == UnitPopupButtons["TankHelpUnitMenu"].text) then
				-- button.func = function() setTankHelpWatch(_G[buttonPrefix.."1"]:GetText(), 1) end
				-- break
			-- end
			
		
			-- i = i + 1
		-- end
	
	-- end
	
-- end

-- hooksecurefunc("ToggleDropDownMenu", TankHelpUnitMenu_OnClick);

local function TankHelpHPUpdate(THUnit)
	
	--update raid nr according to unit name
	setTankHelpWatch(TankHelpWatchName, 0)
	
	local SelfStacks = 0
	local OtherStacks = 0
	local unitHPMax = UnitHealthMax(THUnit)
	local unitHPCurrent = UnitHealth(THUnit)
	
	-- Other tank hp
	_G["TankHelpOtherFrame".."Bar"]:SetMinMaxValues(0, unitHPMax)
	_G["TankHelpOtherFrame".."Bar"]:SetValue(unitHPCurrent)
	_G["TankHelpOtherFrame".."TextFrameLabel"]:SetText(GetUnitName(THUnit));
	
	-- player tank hp
	_G["TankHelpSelfFrame".."Bar"]:SetMinMaxValues(0, UnitHealthMax("player"))
	_G["TankHelpSelfFrame".."Bar"]:SetValue(UnitHealth("player"))
	_G["TankHelpSelfFrame".."TextFrameLabel"]:SetText(GetUnitName("player"));
	
	
	-- other class color
	local playerClass, englishClass = UnitClass(THUnit)
	if(UnitClass(THUnit)) then
		_G["TankHelpOtherFrame".."Bar"]:SetStatusBarColor(unpack(CLASS_COLORS[englishClass]))
	end
	
	
	-- player class color
	local playerClassPlayer, englishClassPlayer = UnitClass("player")
	if(UnitClass("player")) then
		_G["TankHelpSelfFrame".."Bar"]:SetStatusBarColor(unpack(CLASS_COLORS[englishClassPlayer]))
	end
	
	-- player texture and stack
	local texture = ""
	for i=1,40 do 
		local n,_,icon,count,_,dur,exptime,_,_= UnitDebuff("player",i);
		if (DEBUFFS[n]) then
			-- print(n .. ": " .. tonumber(DEBUFFS[n]))
			if (tonumber(DEBUFFS[n]) > 0) then
				texture = icon
				_G["TankHelpSelfFrame".."SideButtonTex"]:SetTexture(texture)
				if(exptime - GetTime() > 0) then
					_G["TankHelpSelfFrame".."DebuffTimer"]:SetText( string.format("%.1f", exptime - GetTime()) )
				else
					_G["TankHelpSelfFrame".."DebuffTimer"]:SetText( "" )
				end
				if (count > tonumber(DEBUFFS[n]) - 1) then
					_G["TankHelpSelfFrame".."SideButtonStackLabel"]:SetTextColor(1.0, 0, 0, 1)
				else
					_G["TankHelpSelfFrame".."SideButtonStackLabel"]:SetTextColor(0, 1.0, 0, 1)
				end
				if(count > 0) then
					_G["TankHelpSelfFrame".."SideButtonStackLabel"]:SetText(count)
				else
					_G["TankHelpSelfFrame".."SideButtonStackLabel"]:SetText("")
				end
				SelfStacks = count
				-- Swap?
				if(count >= tonumber(DEBUFFS[n]) and OtherStacks == 0) then
					if(TankHelpConfig["ShowTaunt"] == 1) then
						_G["TankHelpOtherFrame".."SideButtonTauntLabel"]:SetText("Taunt!")
					end
				else --if(not(DEBUFFS[n])) then
					_G["TankHelpOtherFrame".."SideButtonTauntLabel"]:SetText("")
				end
			else
				
			end
		else
			
		end
	end
	if (texture == "") then
		_G["TankHelpSelfFrame".."SideButtonTex"]:SetTexture(0,0,0,0);
		_G["TankHelpOtherFrame".."SideButtonTauntLabel"]:SetText("")
		_G["TankHelpSelfFrame".."SideButtonStackLabel"]:SetText("")
		_G["TankHelpSelfFrame".."DebuffTimer"]:SetText( "" )
	end

	--other texture and stack
	local texture = ""
	for i=1,40 do 
		local n,_,icon,count,_,dur,exptime,_,_=UnitDebuff(THUnit,i);
		if (DEBUFFS[n]) then
			if (tonumber(DEBUFFS[n]) > 0) then
				texture = icon
				_G["TankHelpOtherFrame".."SideButtonTex"]:SetTexture(texture)
				if(exptime - GetTime() > 0) then
					_G["TankHelpOtherFrame".."DebuffTimer"]:SetText( string.format("%.1f", exptime - GetTime()) )
				else
					_G["TankHelpOtherFrame".."DebuffTimer"]:SetText( "" )
				end
				
				if (count > tonumber(DEBUFFS[n]) - 1) then
					_G["TankHelpOtherFrame".."SideButtonStackLabel"]:SetTextColor(1.0, 0, 0, 1)
				else
					_G["TankHelpOtherFrame".."SideButtonStackLabel"]:SetTextColor(0, 1.0, 0, 1)
				end
				if(count > 0) then
					_G["TankHelpOtherFrame".."SideButtonStackLabel"]:SetText(count)
				else
					_G["TankHelpOtherFrame".."SideButtonStackLabel"]:SetText("")
				end
				OtherStacks = count
				-- Swap?
				if(count >= tonumber(DEBUFFS[n]) and SelfStacks == 0) then
					if(TankHelpConfig["ShowTaunt"] == 1) then
						_G["TankHelpSelfFrame".."SideButtonTauntLabel"]:SetText("Taunt!")
					end
				else --if(not(DEBUFFS[n])) then
					_G["TankHelpSelfFrame".."SideButtonTauntLabel"]:SetText("")
				end
			else
				
			end
		else
			
		end
	end
	if (texture == "") then
		_G["TankHelpOtherFrame".."SideButtonTex"]:SetTexture(0,0,0,0);
		_G["TankHelpOtherFrame".."SideButtonStackLabel"]:SetText("")
		_G["TankHelpSelfFrame".."SideButtonTauntLabel"]:SetText("")
		_G["TankHelpOtherFrame".."DebuffTimer"]:SetText( "" )
	end
	
	if(TankHelpConfig["OnlyRaid"] == 1 and not(UnitInRaid("player")) or TankHelpConfig["Enabled"] == 1 or ( not(GetSpecializationRole(GetSpecialization("player")) == "TANK") and TankHelpConfig["IfTank"] == 1 ) ) then
		_G["TankHelpMainButton"]:Hide()
	else
		_G["TankHelpMainButton"]:Show()
	end
	
	
end

function TankHelp_OnUpdate(self, elapsed)
	self.TimeSinceLastUpdate = (self.TimeSinceLastUpdate or 0) + elapsed;
	if (self.TimeSinceLastUpdate > TankHelp_UpdateInterval) then
        local time = GetTime()
		TankHelpHPUpdate(TankHelpWatch)
		
		self.TimeSinceLastUpdate = 0
		-- print("Test!")
	end
	
	
	
end


function TankHelpUpdateOnConfig()

	if(TankHelpConfig["Locked"] == 1) then
		_G["TankHelpSelfFrame"]:SetMovable(false)
	else
		_G["TankHelpSelfFrame"]:SetMovable(true)
	end
	
	
	if(TankHelpConfig["OnlyRaid"] == 1 and not(UnitInRaid("player"))) then
		_G["TankHelpMainButton"]:Hide()
	else
		_G["TankHelpMainButton"]:Show()
	end
	
end

function TankHelp_Okay()
	
	if(_G["TankHelpOptions".."CheckButtonLock"]:GetChecked() == 1) then
		TankHelpConfig["Locked"] = 1
	elseif(_G["TankHelpOptions".."CheckButtonLock"]:GetChecked() == nil) then
		TankHelpConfig["Locked"] = 0
	end
	if(_G["TankHelpOptions".."CheckButtonLoad"]:GetChecked() == 1) then
		TankHelpConfig["Enabled"] = 1
	elseif(_G["TankHelpOptions".."CheckButtonLoad"]:GetChecked() == nil) then
		TankHelpConfig["Enabled"] = 0
	end
	if(_G["TankHelpOptions".."CheckButtonIfTank"]:GetChecked() == 1) then
		TankHelpConfig["IfTank"] = 1
	elseif(_G["TankHelpOptions".."CheckButtonIfTank"]:GetChecked() == nil) then
		TankHelpConfig["IfTank"] = 0
	end
	if(_G["TankHelpOptions".."CheckButtonOnlyRaid"]:GetChecked() == 1) then
		TankHelpConfig["OnlyRaid"] = 1
	elseif(_G["TankHelpOptions".."CheckButtonOnlyRaid"]:GetChecked() == nil) then
		TankHelpConfig["OnlyRaid"] = 0
	end
	
	if(_G["TankHelpOptions".."CheckButtonTaunt"]:GetChecked() == 1) then
		TankHelpConfig["ShowTaunt"] = 1
	elseif(_G["TankHelpOptions".."CheckButtonTaunt"]:GetChecked() == nil) then
		TankHelpConfig["ShowTaunt"] = 0
	end
	
	TankHelpUpdateOnConfig()
	
end



function TankHelpOptions_OnLoad(panel)
	 -- .. GetAddOnMetadata("TankHelp", "Version")
	panel.name = "TankHelp"
	panel.okay = function() TankHelp_Okay() end;
	panel.cancel = function() TankHelp_CancelOrLoad();  end;
	InterfaceOptions_AddCategory(panel);
	
	_G["TankHelpOptions".."CheckButtonLock".."Text"]:SetText("Lock frames")
	_G["TankHelpOptions".."CheckButtonLoad".."Text"]:SetText("Always hide TankHelp")
	_G["TankHelpOptions".."CheckButtonIfTank".."Text"]:SetText("Only show TankHelp in tank spec")
	_G["TankHelpOptions".."CheckButtonOnlyRaid".."Text"]:SetText("Only show TankHelp in raid")
	_G["TankHelpOptions".."CheckButtonTaunt".."Text"]:SetText("Show taunt warning")
	_G["TankHelpOptions".."TextFrame".."Label"]:SetText("Target whoever you want to watch, and right click the frame with your name.")
	
	if( TankHelpConfig["Locked"] == 1 ) then
		_G["TankHelpOptions".."CheckButtonLock"]:SetChecked(true)
	else
		_G["TankHelpOptions".."CheckButtonLock"]:SetChecked(false)
	end
	if( TankHelpConfig["Enabled"] == 1 ) then
		_G["TankHelpOptions".."CheckButtonLoad"]:SetChecked(true)
	else
		_G["TankHelpOptions".."CheckButtonLoad"]:SetChecked(false)
	end
	if( TankHelpConfig["IfTank"] == 1 ) then
		_G["TankHelpOptions".."CheckButtonIfTank"]:SetChecked(true)
	else
		_G["TankHelpOptions".."CheckButtonIfTank"]:SetChecked(false)
	end
	if( TankHelpConfig["OnlyRaid"] == 1 ) then
		_G["TankHelpOptions".."CheckButtonOnlyRaid"]:SetChecked(true)
	else
		_G["TankHelpOptions".."CheckButtonOnlyRaid"]:SetChecked(false)
	end
	if( TankHelpConfig["ShowTaunt"] == 1 ) then
		_G["TankHelpOptions".."CheckButtonTaunt"]:SetChecked(true)
	else
		_G["TankHelpOptions".."CheckButtonTaunt"]:SetChecked(false)
	end
	
	if(not(currentlySelectedDebuff == "")) then
		_G["TankHelpOptionsTextFrameStack"]:SetText(DEBUFFS[currentlySelectedDebuff])
		_G["TankHelpOptionsTextFrameDescription"]:SetText(DebuffDesc[currentlySelectedDebuff])
	end
end


function TankHelpSelfFrame_OnClick()

	if(UnitName("target")) then
		setTankHelpWatch(UnitName("target"), 1)
		_G["TankHelpOtherFrame"]:Show()
	else
		setTankHelpWatch("", 1)
		_G["TankHelpOtherFrame"]:Hide()
	end
	
	
	
end


local function TankHelp_CancelOrLoad()

end

function TankHelpOptionsCheckButtonLock_OnClick()
	
end

function TankHelpOptionsCheckButtonLoad_OnClick()
	
end

function TankHelpOptionsCheckButtonIfTank_OnClick()
	
end

function TankHelpOptionsCheclButtonOnlyRaid_OnClick()
	
end

function TankHelpOptionsCheckButtonTaunt_OnClick()
	
end

function TankHelpSavePos()
	local point, _, relativePoint, xOfs, yOfs = _G["TankHelpSelfFrame"]:GetPoint()
	-- TankHelpConfig["Pos"] = {point, relativeTo, relativePoint,xOfs, yOfs}
	TankHelpConfig["x"] = xOfs
	TankHelpConfig["y"] = yOfs
	TankHelpConfig["point"] = point
	TankHelpConfig["relativePoint"] = relativePoint
	
end


function OptionsDropDown()
	
	
	for index, value in pairs(DEBUFFS) do 
	 -- DEFAULT_CHAT_FRAME:AddMessage(tostring(index).." : "..value)
		local info = UIDropDownMenu_CreateInfo();
		info.text = tostring(index); -- displayed text
		info.value = tostring(index); -- value to work with instead of displayed text
		info.func = OptionsDropDownOnSelect; -- function to handle selection
		UIDropDownMenu_AddButton(info)
		UIDropDownMenu_SetText(_G["TankHelpOptionsDropDown"], tostring(index))
		currentlySelectedDebuff = tostring(index)
		
	end
	
	
	
end



function OptionsDropDownOnSelect(self, arg1, arg2, checked)
	-- show arguments in default chat
	-- print(self, arg1, arg2, checked);
	
	if (not checked) then
		-- set selected value as selected
		UIDropDownMenu_SetSelectedValue(UIDROPDOWNMENU_OPEN_MENU, self.value);
		-- print(self.value)
		
		-- here comes what you want to do when an entry of the dropdown menu is selected
		-- self.value is the value of the selected entry
		
		_G["TankHelpOptionsTextFrameStack"]:SetText(DEBUFFS[self.value])
		_G["TankHelpOptionsTextFrameDescription"]:SetText(DebuffDesc[self.value])
		currentlySelectedDebuff = self.value
		
	end
end

function OptionsAddButton_OnClick()
	_G["EditDebuffs"]:Show();
end

function OptionsRemoveButton_OnClick()
	if( not(currentlySelectedDebuff == "") ) then
		DEBUFFS[currentlySelectedDebuff] = nil
		DebuffDesc[currentlySelectedDebuff] = nil
		OptionsDropDown()
		_G["TankHelpOptionsTextFrameStack"]:SetText(DEBUFFS[currentlySelectedDebuff])
		_G["TankHelpOptionsTextFrameDescription"]:SetText(DebuffDesc[currentlySelectedDebuff])
	end

end

function OptionsEditButton_OnClick()
	_G["EditDebuffs"]:Show();
	if( not(currentlySelectedDebuff == "") ) then
		_G["EditDebuffs".."DebuffsName"]:SetText(currentlySelectedDebuff)
		_G["EditDebuffs".."DebuffsCount"]:SetText(DEBUFFS[currentlySelectedDebuff])
		_G["EditDebuffs".."ScrollFrame".."Child"]:SetText(DebuffDesc[currentlySelectedDebuff])
	end
end

function EditDebuffsOK_OnClick()
	
	DEBUFFS[_G["EditDebuffs".."DebuffsName"]:GetText()] = _G["EditDebuffs".."DebuffsCount"]:GetText()
	DebuffDesc[_G["EditDebuffs".."DebuffsName"]:GetText()] = _G["EditDebuffs".."ScrollFrame".."Child"]:GetText()
	
	_G["TankHelpOptionsTextFrameStack"]:SetText(DEBUFFS[currentlySelectedDebuff])
	_G["TankHelpOptionsTextFrameDescription"]:SetText(DebuffDesc[currentlySelectedDebuff])
	
	_G["EditDebuffs"]:Hide();
	
end

function EditDebuffsCancel_OnClick()
	_G["EditDebuffs"]:Hide();
	
end